﻿Public Class cbattery

    Private bs As BatteryChargeStatus
    Private ps As PowerStatus
    Private pls As PowerLineStatus

    Private acp, bc As Boolean ' питание вкл / выкл
    Private per As Integer ' Уровень заряда в %
    Private st As Integer ' Степень заряда низкий/средний/высокий
    Private bh, bm, bfth, bftm As Integer ' Время работы в автономном режиме ч:мин

    Private Const LAW_CHARGE = 1 ' Низкий заряд 0-25%
    Private Const MEDIUM_CHARGE = 2 ' средний заряд 25-80%
    Private Const OK_CHARGE = 3 ' Низкий заряд 80-100%

    Public ReadOnly Property ACPower() As Boolean
        Get
            ACPower = acp
        End Get
    End Property
    Public ReadOnly Property IsCarging() As Boolean
        Get
            IsCarging = bc
        End Get
    End Property
    Public ReadOnly Property Percent() As Integer
        Get
            Percent = per
        End Get
    End Property
    Public ReadOnly Property BatStatus() As Integer
        Get
            BatStatus = st
        End Get
    End Property
    Public ReadOnly Property BatRamane() As String
        Get
            Dim sh, sm As String
            If bh < 10 Then sh = "0" & CStr(bh) Else sh = CStr(bh)
            If bm < 10 Then sm = "0" & CStr(bm) Else sm = CStr(bm)
            BatRamane = sh & ":" & sm
        End Get
    End Property
    Public ReadOnly Property BatteryFulltime() As String
        Get
            Dim sh, sm As String
            If bfth < 10 Then sh = "0" & CStr(bfth) Else sh = CStr(bfth)
            If bftm < 10 Then sm = "0" & CStr(bftm) Else sm = CStr(bftm)
            BatteryFulltime = sh & ":" & sm
        End Get
    End Property
    Public Function UpdateBattery() As Boolean

        ps = SystemInformation.PowerStatus

        pls = ps.PowerLineStatus
        bs = ps.BatteryChargeStatus

        bfth = ps.BatteryFullLifetime \ 3600
        bftm = (ps.BatteryFullLifetime - (bfth * 3600)) \ 60

        bh = ps.BatteryLifeRemaining \ 3600
        bm = (ps.BatteryLifeRemaining - (bh * 3600)) \ 60

        per = ps.BatteryLifePercent * 100


        If pls And PowerLineStatus.Offline Then acp = False
        If pls And PowerLineStatus.Online Then acp = True
        If bs And BatteryChargeStatus.High Then st = OK_CHARGE
        If bs And BatteryChargeStatus.Low Then st = MEDIUM_CHARGE
        If bs And BatteryChargeStatus.Critical Then st = LAW_CHARGE
        If bs And BatteryChargeStatus.Charging Then bc = True Else bc = False
        If pls And PowerLineStatus.Unknown Then st = 0

    End Function
End Class
