﻿Option Explicit On
Module mDrCaption
    '



    Private cDrive As System.IO.DriveInfo
    Private lDriveCapacety As Long
    Private lDriveFree As Long
    Private lDriveTotal As Long
    Private bReady As Boolean
    Public sDN As String
    Public Declare Function LoadBitmap Lib "user32" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpBitmapName As String) As Long
    Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long


    Public Function GetDriveInf(ByVal sDriveLetter As String)

        cDrive = My.Computer.FileSystem.GetDriveInfo(sDriveLetter) ' Получаем инфо о диске с буквой - sDriveLetter

        frmDriveCaption.Show() ' отображаем окно свойств
        frmDriveCaption.Text = "Свойства диска  -  " & Mid$(sDriveLetter, 1, 2) ' Заголовок окна

        On Error Resume Next
        If cDrive.VolumeLabel = vbNullString Then ' Если нет метки тома то
            frmDriveCaption.lblName.Text = "Диск - " & Mid$(sDriveLetter, 1, 2) & "   [Без метки]" & ",  [" & cDrive.DriveFormat & "]"
        Else
            frmDriveCaption.lblName.Text = "Диск - " & Mid$(sDriveLetter, 1, 2) & "   [" & cDrive.VolumeLabel & "]" & ",  [" & cDrive.DriveFormat & "]"
        End If
        Select Case cDrive.DriveType ' Загрузка значка в зависимости от типа диска
            Case IO.DriveType.Fixed
                frmDriveCaption.pType.Image = My.Resources.rPanel.HARD.ToBitmap
            Case IO.DriveType.CDRom
                frmDriveCaption.pType.Image = My.Resources.rPanel.CDDVD.ToBitmap
            Case IO.DriveType.Network
                frmDriveCaption.pType.Image = My.Resources.rPanel.NET.ToBitmap
            Case IO.DriveType.NoRootDirectory
                frmDriveCaption.pType.Image = My.Resources.rPanel.netu.ToBitmap
            Case IO.DriveType.Ram
                frmDriveCaption.pType.Image = My.Resources.rPanel.RAM.ToBitmap
            Case IO.DriveType.Removable
                frmDriveCaption.pType.Image = My.Resources.rPanel.usb.ToBitmap
            Case IO.DriveType.Unknown
                frmDriveCaption.pType.Image = My.Resources.rPanel.ask.ToBitmap
        End Select

        ' Получение данных о свободном и занятом пространстве диска и его ёмкости
        lDriveTotal = cDrive.TotalSize / 1024 / 1024

        lDriveFree = cDrive.AvailableFreeSpace / 1024 / 1024
        bReady = cDrive.IsReady
        ' Преобразование величин и их отображение в метках
        frmDriveCaption.cFullProgress.Maximum = (lDriveTotal)
        frmDriveCaption.cFullProgress.Value = (lDriveTotal - lDriveFree)
        frmDriveCaption.lblTotalFree.Text = Formatdata(lDriveFree)
        frmDriveCaption.lblTotal.Text = Formatdata(lDriveTotal)
        frmDriveCaption.lblFull.Text = Formatdata(lDriveTotal)

    End Function

    Public Function Formatdata(ByVal ld As Long) As String
        ' Функция форматирования данных Кб\Мб\Гб с 2-мя знаками после запятой
        Dim sRes As String
        sRes = "0"
        If ld < 1 Then
            sRes = FormatNumber(ld * 1024, 2, , , TriState.True) & "  Кбайт"
        ElseIf ld < 1024 Then
            sRes = FormatNumber(ld, 2, , , TriState.True) & "  Мбайт"
        ElseIf ld > 1024 Then
            sRes = FormatNumber(ld / 1024, 2, , , TriState.True) & "  Гбайт"
        End If
        Formatdata = sRes
    End Function
End Module
